'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var Core = require('react-event-base/Core');
var EventUtils = require('react-event-base/EventUtils');

class Mode extends Core.EventModel {
  initialize() {
    console.log("----Initialize mode [".concat(this.type, "]"));
  }

  destroy() {}

}

var Events = EventUtils.createEventTypes(['Changed']);

class AbstractModeController extends Core.EventModel {
  constructor(data) {
    super(data);
    this.modes = this.modes || {};
  }

  initializeModes(modes) {
    this.modes = modes;
  }

  destroyMode() {
    var {
      mode
    } = this;

    if (mode) {
      mode.destroy();
      delete this.mode;
    }
  }

  changeMode(key) {
    this.destroyMode();
    var ModeConstructor = this.modes[key];

    if (ModeConstructor) {
      this.key = key;
      var mode = this.mode = new ModeConstructor(this.modeArgs);
      mode.initialize();
      this.trigger(Events.Changed);
    } else {
      console.error("[ModeController] Invalid key of mode: ".concat(key));
    }
  }

}

exports.AbstractMode = Mode;
exports.AbstractModeController = AbstractModeController;
exports.ModeControllerEvents = Events;
